local CV = CBW_Battle.Console

//CP Variables
CV.CPMeter = CV_RegisterVar{
	name = "cp_meter",
	defaultvalue = 1500,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 1, MAX = 9999}
}

CV.CPWait = CV_RegisterVar{
	name = "cp_wait",
	defaultvalue = 60,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 10, MAX = 255}
}

CV.CPBonus = CV_RegisterVar{
	name = "cp_bonus",
	defaultvalue = 1000,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 0, MAX = 100000}
}

CV.CPRadius = CV_RegisterVar{
	name = "cp_radius",
	defaultvalue = 384,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 128, MAX = 960}
}

CV.CPHeight = CV_RegisterVar{
	name = "cp_height",
	defaultvalue = 192,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 64, MAX = 960}
}



CV.CPSpawnBounce = CV_RegisterVar{
	name = "cp_spawnbounce",
	defaultvalue = 1,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

CV.CPSpawnAuto = CV_RegisterVar{
	name = "cp_spawnauto",
	defaultvalue = 1,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

CV.CPSpawnScatter = CV_RegisterVar{
	name = "cp_spawnscatter",
	defaultvalue = 1,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

CV.CPSpawnBomb = CV_RegisterVar{
	name = "cp_spawnbomb",
	defaultvalue = 1,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

CV.CPSpawnGrenade = CV_RegisterVar{
	name = "cp_spawngrenade",
	defaultvalue = 1,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

CV.CPSpawnRail = CV_RegisterVar{
	name = "cp_spawnrail",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

CV.CPSpawnInfinity = CV_RegisterVar{
	name = "cp_spawninfinity",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

